/*
***********************************************************************
'C file: ASPIshim.c
'
'Wrapper DLL for the Adaptec WNASPI32.DLL. 
'The adaptec dll is declared as _decl calling convention, 
'however visual basic uses the _stdcall format.
'
'(c) Jon F. Zahornacky - 2002
' E-mail: jonzeke@yahoo.com
'
'This library is free software; you can redistribute it and/or
'modify it under the terms of the GNU Lesser General Public
'License as published by the Free Software Foundation; either
'version 2.1 of the License, or (at your option) any later version.
'
'This library is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
'Lesser General Public License for more details.
'
'You should have received a copy of the GNU Lesser General Public
'License along with this library; if not, write to the Free Software
'Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
'	
***********************************************************************
*/

#define STRICT
#include <windows.h>
#include "cdbackup.h"

// Main Entry Point For DLL
BOOL WINAPI DllMain (HINSTANCE hInstA, DWORD dwReason, LPVOID lpvReserved)
	{
	switch (dwReason)
		{
		case DLL_PROCESS_ATTACH:
			// record this dll's instance

// load MMC1DLL.DLL
   MMC1DllHandle = LoadLibrary ( "MMC1DLL.DLL" );
   if ( MMC1DllHandle == 0 )
      {
        MessageBox ( NULL, "LoadLibrary:\nMMC1DLL.DLL not found.",
                           "Error FS 001", MB_SYSTEMMODAL );
        return;
      }

// load FFAspiStart address
   pfnFFAspiStart = ( bool ( __stdcall *)( HWND ) )
      GetProcAddress ( MMC1DllHandle, "FFAspiStart" );
   if ( pfnFFAspiStart == NULL )
      {
        MessageBox ( NULL, "GetProcAddress:\nFFAspiStart not found.",
                           "Error FS 002", MB_SYSTEMMODAL );
        return;
      }

// load FFCDReadSect address
   pfnFFCDReadSect = ( int ( __stdcall *)( HWND, int, int, int, int, char* ) )
      GetProcAddress ( MMC1DllHandle, "FFCDReadSect" );
   if ( pfnFFCDReadSect == NULL )
      {
        MessageBox ( NULL, "GetProcAddress:\nFFCDReadSect not found.",
                           "Error FS 003", MB_SYSTEMMODAL );
        return;
      }

// load FFCDWrite address
   pfnFFCDWrite = ( int ( __stdcall *)( HWND, int, int, int, HANDLE ) )
      GetProcAddress ( MMC1DllHandle, "FFCDWrite" );
   if ( pfnFFCDWrite == NULL )
      {
        MessageBox ( NULL, "GetProcAddress:\nFFCDWrite not found.",
                           "Error FS 003", MB_SYSTEMMODAL );
        return;
      }

// load FFAspiStop address
   pfnFFAspiStop = ( void ( __stdcall *)( void ) )
      GetProcAddress ( MMC1DllHandle, "FFAspiStop" );
   if ( pfnFFAspiStop == NULL )
      {
        MessageBox ( NULL, "GetProcAddress:\nFFAspiStop not found.",
                           "Error FS 004", MB_SYSTEMMODAL );
        return;
      }
//Check if supports Aspi
   if ( pfnFFAspiStart ( hWnd ) == false )
      {
        MessageBox ( NULL, "No ASPI support.",
                           "Error FS 005", MB_SYSTEMMODAL );
        return;
      }

   int rc;
   unsigned long iBytesWritten;
   char sectBuf [ 2050 ];

BOOL __stdcall WriteISO( PDWROD pdwPath )
	{
	//This will write a ISO to a CD
	}
BOOL __stdcall MakeISO( PDWORD pdwPath )
	{
	//This will make an ISO from a CD
   HANDLE fontHandle = CreateFile ( pdwPath, GENERIC_WRITE, 
                                    FILE_SHARE_WRITE, 0, CREATE_ALWAYS, 
                                    FILE_ATTRIBUTE_NORMAL, 0 );
	   int blocknum = 0;
   while ( true )
      {
       rc = pfnFFCDReadSect ( hWnd, 0, 2, 0, blocknum, sectBuf );
	   MessageBox ( NULL, "Will now write the file!", "Now", MB_SYSTEMMODAL );
       blocknum++;
       if ( rc == 0 ) 
          WriteFile ( fontHandle, sectBuf, 2048, &iBytesWritten, 0 ); 
       else
          break;  // EXIT AT THE FIRST READ ERROR (nothing more to read)
                  // USUALLY the error is SENSE CODE = 5, Additional
                  // Sense Code = 21h, Additional Sense Code Qualifier = 0
                  // (meaning: LBA out of range).
	   return 0
      }

// close the ISO 9660 image file
   CloseHandle ( fontHandle );
   MessageBox ( NULL, "will now close the file", "NOW", MB_SYSTEMMODAL );
   return 0
	}
return 0